Package org.apache.nutch.protocol.http

## Class HttpResponse

- java.lang.Object
- - org.apache.nutch.protocol.http.HttpResponse

- All Implemented Interfaces:
    `HttpHeaders`, `Response`

      public class HttpResponse
      extends Object
      implements Response

  An HTTP response.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `protected static class` | `HttpResponse.Scheme` |

    - ### Nested classes/interfaces inherited from interface org.apache.nutch.net.protocols.Response

      `Response.TruncatedContentReason`

  - ### Field Summary

    - ### Fields inherited from interface org.apache.nutch.metadata.HttpHeaders

      `CLIENT_TRANSFER_ENCODING, CONTENT_DISPOSITION, CONTENT_ENCODING, CONTENT_LANGUAGE, CONTENT_LENGTH, CONTENT_LOCATION, CONTENT_MD5, CONTENT_TYPE, IF_MODIFIED_SINCE, LAST_MODIFIED, LOCATION, TRANSFER_ENCODING, USER_AGENT, WRITABLE_CONTENT_TYPE`

    - ### Fields inherited from interface org.apache.nutch.net.protocols.Response

      `FETCH_TIME, IP_ADDRESS, REQUEST, RESPONSE_HEADERS, TRUNCATED_CONTENT, TRUNCATED_CONTENT_REASON`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HttpResponse​(HttpBase http, URL url, CrawlDatum datum)` | Default public constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `getCode()` | Get the response code.
    `byte[]` | `getContent()` | Get the full content of the response.
    `String` | `getHeader​(String name)` | Get the value of a named header.
    `Metadata` | `getHeaders()` | Get all the headers.
    `URL` | `getUrl()` | Get the URL used to retrieve this response.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### HttpResponse

          public HttpResponse​(HttpBase http,
                              URL url,
                              CrawlDatum datum)
                       throws ProtocolException,
                              IOException

      Default public constructor.
      Parameters:
        `http` - the `HttpBase` for this URL
        `url` - the canonical URL associated with the response
        `datum` - crawl information for the URL
      Throws:
        `ProtocolException` - if the URL does not use HTTP protocol
        `IOException` - if there is a fatal I/O error, typically to do with Socket's

  - ### Method Detail

    - #### getUrl

          public URL getUrl()

      Description copied from interface: `Response`
      Get the URL used to retrieve this response.
      Specified by:
        `getUrl` in interface `Response`
      Returns:
        `URL`

    - #### getCode

          public int getCode()

      Description copied from interface: `Response`
      Get the response code.
      Specified by:
        `getCode` in interface `Response`
      Returns:
        protocol response code (int)

    - #### getHeader

          public String getHeader​(String name)

      Description copied from interface: `Response`
      Get the value of a named header.
      Specified by:
        `getHeader` in interface `Response`
      Parameters:
        `name` - key of the header you wish to retreive
      Returns:
        header value

    - #### getHeaders

          public Metadata getHeaders()

      Description copied from interface: `Response`
      Get all the headers.
      Specified by:
        `getHeaders` in interface `Response`
      Returns:
        populated headers `Metadata`

    - #### getContent

          public byte[] getContent()

      Description copied from interface: `Response`
      Get the full content of the response.
      Specified by:
        `getContent` in interface `Response`
      Returns:
        a byte array representing the response content